Index: branches/christmas_branche/src/lib/collision_detection/cd_engine.cc
===================================================================
--- branches/christmas_branche/src/lib/collision_detection/cd_engine.cc	(revision 6186)
+++ branches/christmas_branche/src/lib/collision_detection/cd_engine.cc	(revision 6187)
@@ -19,5 +19,4 @@
 #include "obb_tree.h"
 #include "debug.h"
-#include "list.h"
 
 #include "model.h"
Index: branches/christmas_branche/src/lib/collision_detection/obb.cc
===================================================================
--- branches/christmas_branche/src/lib/collision_detection/obb.cc	(revision 6186)
+++ branches/christmas_branche/src/lib/collision_detection/obb.cc	(revision 6187)
@@ -17,5 +17,4 @@
 
 #include "obb.h"
-#include "list.h"
 #include "vector.h"
 
Index: branches/christmas_branche/src/lib/graphics/graphics_engine.cc
===================================================================
--- branches/christmas_branche/src/lib/graphics/graphics_engine.cc	(revision 6186)
+++ branches/christmas_branche/src/lib/graphics/graphics_engine.cc	(revision 6187)
@@ -37,5 +37,4 @@
 #ifdef __WIN32__
  #include "class_list.h"
- #include "list.h"
  #include "static_model.h"
 #endif
@@ -579,6 +578,6 @@
   std::list<WorldEntity*>::const_iterator entity;
   for (entity = drawList.begin(); entity != drawList.end(); entity++)
-    if ((*entity)->isVisible()) 
-      (*entity)->draw(); 
+    if ((*entity)->isVisible())
+      (*entity)->draw();
 }
 
Index: branches/christmas_branche/src/lib/graphics/render2D/render_2d.cc
===================================================================
--- branches/christmas_branche/src/lib/graphics/render2D/render_2d.cc	(revision 6186)
+++ branches/christmas_branche/src/lib/graphics/render2D/render_2d.cc	(revision 6187)
@@ -20,5 +20,4 @@
 #include "graphics_engine.h"
 #include "class_list.h"
-#include "list.h"
 #include "element_2d.h"
 
Index: branches/christmas_branche/src/lib/graphics/text_engine/text_engine.cc
===================================================================
--- branches/christmas_branche/src/lib/graphics/text_engine/text_engine.cc	(revision 6186)
+++ branches/christmas_branche/src/lib/graphics/text_engine/text_engine.cc	(revision 6187)
@@ -37,5 +37,4 @@
 
 #include "debug.h"
-#include "list.h"
 
 ///////////////////
Index: branches/christmas_branche/src/lib/shell/shell.cc
===================================================================
--- branches/christmas_branche/src/lib/shell/shell.cc	(revision 6186)
+++ branches/christmas_branche/src/lib/shell/shell.cc	(revision 6187)
@@ -23,5 +23,4 @@
 
 #include "text.h"
-#include "list.h"
 #include "graphics_engine.h"
 #include "material.h"
Index: branches/christmas_branche/src/lib/shell/shell_buffer.cc
===================================================================
--- branches/christmas_branche/src/lib/shell/shell_buffer.cc	(revision 6186)
+++ branches/christmas_branche/src/lib/shell/shell_buffer.cc	(revision 6187)
@@ -18,5 +18,4 @@
 #include "shell_buffer.h"
 #include "debug.h"
-#include "list.h"
 #include "shell.h"
 
Index: branches/christmas_branche/src/lib/shell/shell_command.cc
===================================================================
--- branches/christmas_branche/src/lib/shell/shell_command.cc	(revision 6186)
+++ branches/christmas_branche/src/lib/shell/shell_command.cc	(revision 6187)
@@ -19,5 +19,5 @@
 #include "shell_command_class.h"
 
-#include "list.h"
+#include "compiler.h"
 #include "debug.h"
 #include "class_list.h"
Index: branches/christmas_branche/src/lib/shell/shell_input.cc
===================================================================
--- branches/christmas_branche/src/lib/shell/shell_input.cc	(revision 6186)
+++ branches/christmas_branche/src/lib/shell/shell_input.cc	(revision 6187)
@@ -26,5 +26,4 @@
 
 #include "debug.h"
-#include "list.h"
 #include "compiler.h"
 #include "stdlibincl.h"
Index: branches/christmas_branche/src/lib/sound/sound_engine.cc
===================================================================
--- branches/christmas_branche/src/lib/sound/sound_engine.cc	(revision 6186)
+++ branches/christmas_branche/src/lib/sound/sound_engine.cc	(revision 6187)
@@ -24,5 +24,4 @@
 
 #include "p_node.h"
-#include "list.h"
 #include "resource_manager.h"
 #include "debug.h"
Index: branches/christmas_branche/src/lib/util/executor/executor.cc
===================================================================
--- branches/christmas_branche/src/lib/util/executor/executor.cc	(revision 6186)
+++ branches/christmas_branche/src/lib/util/executor/executor.cc	(revision 6187)
@@ -18,5 +18,4 @@
 #include "executor.h"
 
-#include "list.h"
 #include "debug.h"
 #include "class_list.h"
Index: branches/christmas_branche/src/story_entities/debug_world.cc
===================================================================
--- branches/christmas_branche/src/story_entities/debug_world.cc	(revision 6186)
+++ branches/christmas_branche/src/story_entities/debug_world.cc	(revision 6187)
@@ -48,5 +48,4 @@
 
 #include "glmenu_imagescreen.h"
-#include "list.h"
 #include "game_loader.h"
 
Index: branches/christmas_branche/src/story_entities/network_world.cc
===================================================================
--- branches/christmas_branche/src/story_entities/network_world.cc	(revision 6186)
+++ branches/christmas_branche/src/story_entities/network_world.cc	(revision 6187)
@@ -48,5 +48,4 @@
 
 #include "glmenu_imagescreen.h"
-#include "list.h"
 #include "game_loader.h"
 
Index: branches/christmas_branche/src/story_entities/world.cc
===================================================================
--- branches/christmas_branche/src/story_entities/world.cc	(revision 6186)
+++ branches/christmas_branche/src/story_entities/world.cc	(revision 6187)
@@ -46,5 +46,4 @@
 
 #include "glmenu_imagescreen.h"
-#include "list.h"
 #include "game_loader.h"
 
Index: branches/christmas_branche/src/util/animation/animation.h
===================================================================
--- branches/christmas_branche/src/util/animation/animation.h	(revision 6186)
+++ branches/christmas_branche/src/util/animation/animation.h	(revision 6187)
@@ -7,9 +7,8 @@
 #define _ANIMATION_H
 
-#include "list.h"
 #include "base_object.h"
-#include "confincl.h"  // must be here to determin the DEBUG-level
 #include "debug.h"
 
+#include "list.h"
 // FORWARD DECLARATION
 
Index: branches/christmas_branche/src/util/loading/resource_manager.h
===================================================================
--- branches/christmas_branche/src/util/loading/resource_manager.h	(revision 6186)
+++ branches/christmas_branche/src/util/loading/resource_manager.h	(revision 6187)
@@ -20,4 +20,5 @@
 
 #include "base_object.h"
+
 
 #include <list>
Index: branches/christmas_branche/src/world_entities/npcs/npc.cc
===================================================================
--- branches/christmas_branche/src/world_entities/npcs/npc.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/npcs/npc.cc	(revision 6187)
@@ -22,5 +22,4 @@
 
 #include "state.h"
-#include "list.h"
 #include "stdlibincl.h"
 #include "power_ups/turret_power_up.h"
Index: branches/christmas_branche/src/world_entities/npcs/npc_test.cc
===================================================================
--- branches/christmas_branche/src/world_entities/npcs/npc_test.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/npcs/npc_test.cc	(revision 6187)
@@ -23,5 +23,4 @@
 #include "shader.h"
 #include "state.h"
-#include "list.h"
 #include "stdlibincl.h"
 #include "debug.h"
Index: branches/christmas_branche/src/world_entities/npcs/npc_test1.cc
===================================================================
--- branches/christmas_branche/src/world_entities/npcs/npc_test1.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/npcs/npc_test1.cc	(revision 6187)
@@ -22,6 +22,4 @@
 
 #include "state.h"
-#include "list.h"
-#include "stdlibincl.h"
 #include "power_ups/turret_power_up.h"
 #include "power_ups/laser_power_up.h"
Index: branches/christmas_branche/src/world_entities/power_ups/laser_power_up.cc
===================================================================
--- branches/christmas_branche/src/world_entities/power_ups/laser_power_up.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/power_ups/laser_power_up.cc	(revision 6187)
@@ -19,5 +19,4 @@
 #include "factory.h"
 #include "state.h"
-#include "list.h"
 
 #include "primitive_model.h"
Index: branches/christmas_branche/src/world_entities/power_ups/param_power_up.cc
===================================================================
--- branches/christmas_branche/src/world_entities/power_ups/param_power_up.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/power_ups/param_power_up.cc	(revision 6187)
@@ -19,5 +19,4 @@
 #include "factory.h"
 #include "state.h"
-#include "list.h"
 
 #include "primitive_model.h"
Index: branches/christmas_branche/src/world_entities/power_ups/turret_power_up.cc
===================================================================
--- branches/christmas_branche/src/world_entities/power_ups/turret_power_up.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/power_ups/turret_power_up.cc	(revision 6187)
@@ -19,5 +19,4 @@
 #include "factory.h"
 #include "state.h"
-#include "list.h"
 
 #include "primitive_model.h"
Index: branches/christmas_branche/src/world_entities/power_ups/weapon_power_up.cc
===================================================================
--- branches/christmas_branche/src/world_entities/power_ups/weapon_power_up.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/power_ups/weapon_power_up.cc	(revision 6187)
@@ -19,5 +19,4 @@
 #include "factory.h"
 #include "state.h"
-#include "list.h"
 
 #include "primitive_model.h"
Index: branches/christmas_branche/src/world_entities/satellite.cc
===================================================================
--- branches/christmas_branche/src/world_entities/satellite.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/satellite.cc	(revision 6187)
@@ -21,5 +21,4 @@
 
 #include "objModel.h"
-#include "list.h"
 #include "vector.h"
 
Index: branches/christmas_branche/src/world_entities/test_entity.cc
===================================================================
--- branches/christmas_branche/src/world_entities/test_entity.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/test_entity.cc	(revision 6187)
@@ -24,5 +24,4 @@
 #include "obb_tree.h"
 #include "state.h"
-#include "list.h"
 
 using namespace std;
Index: branches/christmas_branche/src/world_entities/weapons/aim.cc
===================================================================
--- branches/christmas_branche/src/world_entities/weapons/aim.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/weapons/aim.cc	(revision 6187)
@@ -21,5 +21,4 @@
 #include "graphics_engine.h"
 #include "state.h"
-#include "list.h"
 #include "material.h"
 #include "t_animation.h"
Index: branches/christmas_branche/src/world_entities/weapons/bomb.cc
===================================================================
--- branches/christmas_branche/src/world_entities/weapons/bomb.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/weapons/bomb.cc	(revision 6187)
@@ -21,5 +21,5 @@
 
 #include "fast_factory.h"
-#include "list.h"
+
 
 #include "object_manager.h"
Index: branches/christmas_branche/src/world_entities/weapons/guided_missile.cc
===================================================================
--- branches/christmas_branche/src/world_entities/weapons/guided_missile.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/weapons/guided_missile.cc	(revision 6187)
@@ -20,7 +20,5 @@
 #include "fast_factory.h"
 
-#include "model.h"
 #include "state.h"
-#include "list.h"
 #include "class_list.h"
 
Index: branches/christmas_branche/src/world_entities/weapons/laser.cc
===================================================================
--- branches/christmas_branche/src/world_entities/weapons/laser.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/weapons/laser.cc	(revision 6187)
@@ -21,5 +21,4 @@
 
 #include "state.h"
-#include "list.h"
 #include "class_list.h"
 #include "model.h"
Index: branches/christmas_branche/src/world_entities/weapons/rocket.cc
===================================================================
--- branches/christmas_branche/src/world_entities/weapons/rocket.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/weapons/rocket.cc	(revision 6187)
@@ -20,7 +20,5 @@
 #include "fast_factory.h"
 
-#include "model.h"
 #include "state.h"
-#include "list.h"
 #include "class_list.h"
 
Index: branches/christmas_branche/src/world_entities/weapons/test_bullet.cc
===================================================================
--- branches/christmas_branche/src/world_entities/weapons/test_bullet.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/weapons/test_bullet.cc	(revision 6187)
@@ -20,7 +20,5 @@
 #include "fast_factory.h"
 
-#include "model.h"
 #include "state.h"
-#include "list.h"
 #include "class_list.h"
 
Index: branches/christmas_branche/src/world_entities/weapons/test_gun.cc
===================================================================
--- branches/christmas_branche/src/world_entities/weapons/test_gun.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/weapons/test_gun.cc	(revision 6187)
@@ -29,6 +29,4 @@
 #include "factory.h"
 
-#include "vector.h"
-#include "list.h"
 #include "animation3d.h"
 
Index: branches/christmas_branche/src/world_entities/weapons/turret.cc
===================================================================
--- branches/christmas_branche/src/world_entities/weapons/turret.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/weapons/turret.cc	(revision 6187)
@@ -23,5 +23,4 @@
 
 #include "state.h"
-#include "list.h"
 #include "animation3d.h"
 
Index: branches/christmas_branche/src/world_entities/world_entity.cc
===================================================================
--- branches/christmas_branche/src/world_entities/world_entity.cc	(revision 6186)
+++ branches/christmas_branche/src/world_entities/world_entity.cc	(revision 6187)
@@ -24,5 +24,4 @@
 #include "resource_manager.h"
 #include "load_param.h"
-#include "list.h"
 #include "vector.h"
 #include "obb_tree.h"