Index: branches/christmas_branche/src/lib/graphics/importer/md2Model.cc
===================================================================
--- branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6205)
+++ branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6207)
@@ -33,10 +33,4 @@
   #include "anormtab.h"
 };
-
-//! again one of these strange id software parts
-static float *shadeDots = MD2Model::anormsDots[0];
-
-
-static sVec3D verticesList[MD2_MAX_VERTICES];
 
 
@@ -90,4 +84,5 @@
   this->scaleFactor = this->data->scaleFactor;
 
+  shadeDots = MD2Model::anormsDots[0];
   /* set the animation stat mannualy */
   this->animationState.type = STAND;
@@ -111,10 +106,10 @@
 /**
  *  initializes an array of vert with the current frame scaled vertices
- * @param verticesList: the list of vertices to interpolate between
+ * @param this->verticesList: the list of vertices to interpolate between
 
    we won't use the pVertices array directly, since its much easier and we need
    saving of data anyway
 */
-void MD2Model::interpolate(/*sVec3D* verticesList*/)
+void MD2Model::interpolate(/*sVec3D* this->verticesList*/)
 {
   sVec3D* currVec;
@@ -126,7 +121,7 @@
   for( int i = 0; i < this->data->numVertices; ++i)
     {
-      verticesList[i][0] = currVec[i][0] + this->animationState.interpolationState * (nextVec[i][0] - currVec[i][0]);
-      verticesList[i][1] = currVec[i][1] + this->animationState.interpolationState * (nextVec[i][1] - currVec[i][1]);
-      verticesList[i][2] = currVec[i][2] + this->animationState.interpolationState * (nextVec[i][2] - currVec[i][2]);
+      this->verticesList[i][0] = currVec[i][0] + this->animationState.interpolationState * (nextVec[i][0] - currVec[i][0]);
+      this->verticesList[i][1] = currVec[i][1] + this->animationState.interpolationState * (nextVec[i][1] - currVec[i][1]);
+      this->verticesList[i][2] = currVec[i][2] + this->animationState.interpolationState * (nextVec[i][2] - currVec[i][2]);
     }
 }
@@ -172,5 +167,5 @@
   this->animate(time);
   this->processLighting();
-  this->interpolate(/*verticesList*/);
+  this->interpolate(/*this->verticesList*/);
 }
 
@@ -185,5 +180,5 @@
   glPushMatrix();
   this->renderFrame();
-//   renderFrameTriangles();
+  // renderFrameTriangles();
   glPopMatrix();
 }
@@ -222,5 +217,5 @@
           glTexCoord2f( ((float *)pCommands)[0], ((float *)pCommands)[1] );
           glNormal3fv(anorms[this->data->pLightNormals[pCommands[2]]]);
-          glVertex3fv(verticesList[pCommands[2]]);
+          glVertex3fv(this->verticesList[pCommands[2]]);
         }
       glEnd();
@@ -234,5 +229,5 @@
 void MD2Model::renderFrameTriangles() const
 {
-  //static sVec3D verticesList[MD2_MAX_VERTICES]; /* performance: created only once in a lifetime */
+  //static sVec3D this->verticesList[MD2_MAX_VERTICES]; /* performance: created only once in a lifetime */
   int* pCommands = this->data->pGLCommands;
   /* some face culling stuff */
@@ -243,5 +238,5 @@
 //
 //   this->processLighting();
-//   this->interpolate(/*verticesList*/);
+//   this->interpolate(/*this->verticesList*/);
   this->data->material->select();
 
Index: branches/christmas_branche/src/lib/graphics/importer/md2Model.h
===================================================================
--- branches/christmas_branche/src/lib/graphics/importer/md2Model.h	(revision 6205)
+++ branches/christmas_branche/src/lib/graphics/importer/md2Model.h	(revision 6207)
@@ -241,4 +241,6 @@
   static float        anormsDots[SHADEDOT_QUANT][256];  //!< the anormals dot products
   static sAnim        animationList[21];                //!< the anomation list
+   //! again one of these strange id software parts
+  float*              shadeDots;
 
   MD2Data*            data;                             //!< the md2 data pointer
@@ -247,4 +249,5 @@
   float               scaleFactor;                      //!< the scale factor (individual)
   sAnimState          animationState;                   //!< animation state of the model
+  sVec3D              verticesList[MD2_MAX_VERTICES];   //!< place to temp sav the vert
 };
 