Index: branches/avi_play/src/subprojects/importer/Makefile.am
===================================================================
--- branches/avi_play/src/subprojects/importer/Makefile.am	(revision 6260)
+++ branches/avi_play/src/subprojects/importer/Makefile.am	(revision 6286)
@@ -7,5 +7,6 @@
 
 bin_PROGRAMS = importer \
-               multitex
+               multitex \
+							 movie_player_test
 
 importer_LDADD = $(MAINSRCDIR)/lib/event/libORXevent.a \
@@ -63,2 +64,29 @@
                   $(MAINSRCDIR)/lib/util/executor/executor.cc \
                   $(MAINSRCDIR)/util/loading/factory.cc
+
+movie_player_test_LDADD = $(MAINSRCDIR)/lib/event/libORXevent.a \
+                 					$(MAINSRCDIR)/lib/parser/tinyxml/libtinyxml.a \
+                 					$(MAINSRCDIR)/lib/graphics/libORXgraphics.a \
+                 					$(MAINSRCDIR)/lib/shell/libORXshell.a \
+                 					$(MAINSRCDIR)/lib/sound/libORXsound.a \
+                 					$(MAINSRCDIR)/lib/graphics/importer/libORXimporter.a
+
+movie_player_test_SOURCES= ../framework.cc \
+                  				 movie_player_test.cc \
+                  				 $(MAINSRCDIR)/util/state.cc \
+                  				 $(MAINSRCDIR)/world_entities/camera.cc \
+                  				 $(MAINSRCDIR)/lib/lang/base_object.cc \
+													 $(MAINSRCDIR)/lib/lang/class_list.cc \
+													 $(MAINSRCDIR)/lib/math/vector.cc \
+													 $(MAINSRCDIR)/util/loading/resource_manager.cc \
+													 $(MAINSRCDIR)/lib/parser/ini_parser/ini_parser.cc \
+													 $(MAINSRCDIR)/lib/coord/p_node.cc \
+													 $(MAINSRCDIR)/lib/coord/null_parent.cc \
+													 $(MAINSRCDIR)/util/loading/load_param.cc \
+													 $(MAINSRCDIR)/util/loading/load_param_description.cc \
+													 $(MAINSRCDIR)/lib/util/helper_functions.cc \
+													 $(MAINSRCDIR)/lib/util/substring.cc \
+													 $(MAINSRCDIR)/lib/util/color.cc \
+													 $(MAINSRCDIR)/lib/util/multi_type.cc \
+													 $(MAINSRCDIR)/lib/util/executor/executor.cc \
+													 $(MAINSRCDIR)/util/loading/factory.cc
Index: branches/avi_play/src/subprojects/importer/importer.cc
===================================================================
--- branches/avi_play/src/subprojects/importer/importer.cc	(revision 6260)
+++ branches/avi_play/src/subprojects/importer/importer.cc	(revision 6286)
@@ -10,5 +10,5 @@
 
    ### File Specific:
-   main-programmer: Benjamin Grauer
+   main-programmer: David Hasenfratz
    co-programmer: ...
 
@@ -20,6 +20,4 @@
 #include "light.h"
 
-#include "objModel.h"
-#include "primitive_model.h"
 #include "media_container.h"
 #include <stdlib.h>
@@ -27,5 +25,4 @@
 #include "resource_manager.h"
 
-Model* obj;
 MediaContainer* movie;
 
@@ -44,13 +41,5 @@
 void Framework::moduleEventHandler(SDL_Event* event)
 {
-  switch (event->type)
-    {
-    case SDL_KEYDOWN:
-      switch (event->key.keysym.sym)
-        {
-        case SDLK_i:
-          break;
-        }
-    }
+
 }
 
@@ -66,5 +55,4 @@
 }
 
-
 void Framework::moduleHelp(void) const
 {
Index: branches/avi_play/src/subprojects/importer/movie_player_test.cc
===================================================================
--- branches/avi_play/src/subprojects/importer/movie_player_test.cc	(revision 6286)
+++ branches/avi_play/src/subprojects/importer/movie_player_test.cc	(revision 6286)
@@ -0,0 +1,58 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: David Hasenfratz
+   co-programmer: ...
+
+   this file extends the framework file, so it renders what i want.
+*/
+
+#include "framework.h"
+
+#include "light.h"
+
+#include "texture_sequence.h"
+#include "material.h"
+
+#include "objModel.h"
+
+#include "primitive_model.h"
+#include <stdlib.h>
+
+#include "resource_manager.h"
+#include "media_container.h"
+
+
+void Framework::moduleInit(int argc, char** argv)
+{
+
+}
+
+void Framework::moduleEventHandler(SDL_Event* event)
+{
+
+}
+
+void Framework::moduleTick(float dt)
+{
+
+}
+
+void Framework::moduleDraw(void) const
+{
+
+}
+
+
+void Framework::moduleHelp(void) const
+{
+
+}
Index: branches/avi_play/src/subprojects/importer/multitex.cc
===================================================================
--- branches/avi_play/src/subprojects/importer/multitex.cc	(revision 6260)
+++ branches/avi_play/src/subprojects/importer/multitex.cc	(revision 6286)
@@ -10,5 +10,5 @@
 
    ### File Specific:
-   main-programmer: Benjamin Grauer
+   main-programmer: David Hasenfratz
    co-programmer: ...
 
@@ -22,6 +22,4 @@
 #include "texture_sequence.h"
 #include "material.h"
-
-#include "objModel.h"
 
 #include "primitive_model.h"