Index: branches/avi_play/src/subprojects/importer/importer.cc
===================================================================
--- branches/avi_play/src/subprojects/importer/importer.cc	(revision 6333)
+++ branches/avi_play/src/subprojects/importer/importer.cc	(revision 6339)
@@ -25,15 +25,8 @@
 #include "resource_manager.h"
 
-MediaContainer* movie;
 
 void Framework::moduleInit(int argc, char** argv)
 {
 
-  movie = new MediaContainer(argv[1]);
-
-  // print information about the media file
-  movie->printMediaInformation();
-
-  SDL_Delay(1000);
 
 }
@@ -46,6 +39,5 @@
 void Framework::moduleTick(float dt)
 {
-  while(movie->getNextFrame() != NULL);
-    movie->saveCurrentFrame();	
+
 }
 
Index: branches/avi_play/src/subprojects/importer/movie_player_test.cc
===================================================================
--- branches/avi_play/src/subprojects/importer/movie_player_test.cc	(revision 6333)
+++ branches/avi_play/src/subprojects/importer/movie_player_test.cc	(revision 6339)
@@ -21,16 +21,16 @@
 #include "movie_player.h"
 
-MoviePlayer* movie_player;
+//MoviePlayer* movie_player;
 
 void Framework::moduleInit(int argc, char** argv)
 {
-  movie_player = new MoviePlayer(argv[1]);
+  //movie_player = new MoviePlayer(argv[1]);
 
-  movie_player->printInformation();
+  //movie_player->printInformation();
 }
 
 void Framework::moduleEventHandler(SDL_Event* event)
 {
-  switch (event->type)
+  /*switch (event->type)
   {
     case SDL_KEYDOWN:
@@ -58,15 +58,15 @@
           break;
       }
-  }
+  }*/
 }
 
 void Framework::moduleTick(float dt)
 {
-  movie_player->tick(dt);
+  //movie_player->tick(dt);
 }
 
 void Framework::moduleDraw(void) const
 {
-  movie_player->draw();
+  //movie_player->draw();
 }
 
Index: branches/avi_play/src/subprojects/importer/multitex.cc
===================================================================
--- branches/avi_play/src/subprojects/importer/multitex.cc	(revision 6333)
+++ branches/avi_play/src/subprojects/importer/multitex.cc	(revision 6339)
@@ -20,7 +20,5 @@
 #include "light.h"
 
-#include "texture_sequence.h"
 #include "material.h"
-
 #include "primitive_model.h"
 #include <stdlib.h>
@@ -29,7 +27,6 @@
 
 Model* obj;
-TextureSequence* seq;
 Material* testMat;
-MediaContainer* movie;
+MediaContainer* media_container;
 
 int counter = 0;
@@ -40,33 +37,15 @@
 void Framework::moduleInit(int argc, char** argv)
 {
-  if( argc <= 2)
+  if( argc <= 1)
   {
     printf("Wrong arguments try following notations:\n");
-    printf("./multitex [media_file] [start_time]\n");
+    printf("./multitex [media_file]\n");
     exit(0);
   }
 
-  movie = new MediaContainer(argv[1]);
-  //movie = new MediaContainer();
-  //movie->loadMedia(argv[1]);
-  fps = movie->getFPS();
-
-  int start_frame = atoi(argv[2]);
-
-  // print information about the media file
-  movie->printMediaInformation();
+  media_container = new MediaContainer(argv[1]);
 
   testMat = new Material;
-
-  seq = new TextureSequence();
-
-  // get each fram individually
-  //while(seq->addFrame(movie->getNextFrame()) != NULL);
-  // get a list of frames
-  movie->gotoFrame(start_frame);
-  seq->addFrameList(movie->getFrameList());
-
   testMat->setDiffuseMap("maps/radialTransparency.png");
-
   obj = new PrimitiveModel(PRIM_PLANE, 10.0);
 
@@ -75,4 +54,6 @@
   (new Light())->setAbsCoor(5.0, 10.0, 40.0);
   (new Light())->setAbsCoor(-10, -20, -100);
+
+  fps = media_container->getFPS();
 }
 
@@ -96,5 +77,5 @@
         case SDLK_9:
           fps++;
-          PRINTF(1)("fps: %f\n", fps);
+          PRINTF(0)("fps: %0.2f\n", fps);
           break;
         // decrease fps
@@ -102,5 +83,5 @@
           if(fps > 0)
             fps--;
-          PRINTF(1)("fps: %f\n", fps);
+          PRINTF(0)("fps: %0.2f\n", fps);
           break;
         }
@@ -116,11 +97,9 @@
     counter = fps * timer;
 
-    if (counter > seq->getFrameCount())
+    if (counter >= media_container->getFrameCount())
     {
       timer = 0;
       counter = 0;
     }
-
-    seq->gotoFrame(counter);
   }
 }
@@ -129,5 +108,5 @@
 {
   testMat->select();
-  glBindTexture(GL_TEXTURE_2D, seq->getTexture());
+  glBindTexture(GL_TEXTURE_2D, media_container->getFrameTexture(counter));
   obj->draw();
 
@@ -135,5 +114,4 @@
 }
 
-
 void Framework::moduleHelp(void) const
 {