Index: code/branches/presentation2/data/gui/scripts/GUITools.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/GUITools.lua	(revision 6370)
+++ code/branches/presentation2/data/gui/scripts/GUITools.lua	(revision 6387)
@@ -14,9 +14,9 @@
 function getMinTextSize(window)
     local size = {}
-    
+
     local lookAndFeel = CEGUI.WidgetLookManager:getSingleton():getWidgetLook(window:getLookNFeel())
     local height = window:getFont():getLineSpacing() + window:getUnclippedPixelRect():getHeight() - lookAndFeel:getNamedArea("WithFrameTextRenderArea"):getArea():getPixelRect(window):getHeight()
     local width =  window:getFont():getTextExtent(window:getText()) + window:getUnclippedPixelRect():getWidth() - lookAndFeel:getNamedArea("WithFrameTextRenderArea"):getArea():getPixelRect(window):getWidth()
-    
+
     table.insert(size, height)
     table.insert(size, width)
Index: code/branches/presentation2/data/gui/scripts/InitialiseGUI.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/InitialiseGUI.lua	(revision 6370)
+++ code/branches/presentation2/data/gui/scripts/InitialiseGUI.lua	(revision 6387)
@@ -81,5 +81,5 @@
         hideCursor()
     end
-    
+
     if find( activeSheets, filename ) ~= nil then
         table.remove( activeSheets, find( activeSheets, filename ) )
@@ -96,5 +96,5 @@
     bHidePrevious[filename]=hidePrevious
     cursorVisibility[filename] = bCursorVisible
-    
+
     if hidePrevious == true then
         for i=1,nrOfActiveSheets-1 do
Index: code/branches/presentation2/data/gui/scripts/KeyBindMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/KeyBindMenu.lua	(revision 6370)
+++ code/branches/presentation2/data/gui/scripts/KeyBindMenu.lua	(revision 6387)
@@ -70,8 +70,8 @@
     sampleWindow = winMgr:createWindow("TaharezLook/StaticText", "orxonox/KeyBindPane/SampleWindow")
     sampleWindow:setText("SampleText")
-    
+
     local size = getMinTextSize(sampleWindow)
     lineHeight = size[1]
-    
+
     commandWidth = 0
     for k,v in pairs(commandList) do
@@ -86,5 +86,5 @@
     size = getMinTextSize(sampleWindow)
     addWidth = size[2]
-    
+
     sampleWindow:setText("X")
     size = getMinTextSize(sampleWindow)
@@ -92,5 +92,5 @@
 
     spaceWidth = math.floor(1/14*commandWidth)
-    
+
     buttonWidth = 145
 
@@ -166,5 +166,5 @@
 
     line:setWidth(CEGUI.UDim(0, offset+clearWidth))
-    
+
     return line
 end
@@ -178,5 +178,5 @@
         window:addChildWindow(line)
     end
-    
+
     pane = tolua.cast(window, "CEGUI::ScrollablePane")
     pane:setVerticalStepSize(getScrollingStepSize(window))
@@ -216,5 +216,5 @@
     local commandNr = tonumber(match())
     local buttonNr = tonumber(match())
- 
+
     orxonox.KeyBinderManager:getInstance():unbind(orxonox.KeyBinderManager:getInstance():getCurrent():getBinding(commandList[commandNr], buttonNr))
 
Index: code/branches/presentation2/data/gui/scripts/PickupInventory.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/PickupInventory.lua	(revision 6370)
+++ code/branches/presentation2/data/gui/scripts/PickupInventory.lua	(revision 6387)
@@ -20,5 +20,5 @@
     local equipCount = orxonox.PickupInventory:getEquipmentCount()
     local usableCount = orxonox.PickupInventory:getUsableCount()
-    
+
     if equipCount ~= self.lastEquipmentCount_ or usableCount ~= self.lastUsableCount_ then
         self:updateTabs()
@@ -39,9 +39,9 @@
     local t = name:sub(25, 27)
     local i = name:sub(29)
-    
+
     if t == "equ" then
-        
+
     end
-    
+
     if t == "use" then
         if self.currentUsableID_ >= 0 then
@@ -60,5 +60,5 @@
     orxonox.PickupInventory:getSingleton():clearInventory(winMgr, eqWin, usWin)
     orxonox.PickupInventory:getSingleton():updateTabs(winMgr, eqWin, usWin)
-    
+
     self.currentUsableID_ = orxonox.PickupInventory:getCurrentUsableIndex()
     self.lastEquipmentCount_ = orxonox.PickupInventory:getEquipmentCount()
Index: code/branches/presentation2/data/gui/scripts/QuestGUI.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/QuestGUI.lua	(revision 6370)
+++ code/branches/presentation2/data/gui/scripts/QuestGUI.lua	(revision 6387)
@@ -15,5 +15,5 @@
 
     local questManager = orxonox.QuestManager:getInstance()
-      
+
     local questsList = winMgr:getWindow("orxonox/QuestGUI/QuestsList")
 